OGRE: Ogre::CompositorPassScene Class Reference

| OGRE 2.2.4 Object-Oriented Graphics Rendering Engine

Public Member Functions | List of all members
Ogre::CompositorPassScene Class Reference
Core » Effects

Implementation of CompositorPass This implementation will perform main rendering, selecting several parameters (like viewport's visibility mask, first and last render queue to render) it will render the main scene. More...

`#include <OgreCompositorPassScene.h>`

Inheritance diagram for Ogre::CompositorPassScene:
[legend]

## Public Member Functions
| CompositorPassScene (const CompositorPassSceneDef *definition, Camera *defaultCamera, const RenderTargetViewDef *rtv, CompositorNode *parentNode)
| Constructor. More...
| ~CompositorPassScene ()
virtual void | _placeBarriersAndEmulateUavExecution (BoundUav boundUavs[64], ResourceAccessMap &uavsAccess, ResourceLayoutMap &resourcesLayout)
| Emulates the execution of a UAV to understand memory dependencies, and adds a memory barrier / resource transition if we need to. More...
void | _removeAllBarriers (void)
void | _setCustomCamera (Camera *camera)
void | _setCustomCullCamera (Camera *camera)
void | _setUpdateShadowNode (bool update)
void | addResourceTransition (ResourceLayoutMap::iterator currentLayout, ResourceLayout::Layout newLayout, uint32 readBarrierBits)
virtual void | execute (const Camera *lodCamera)
Vector2 | getActualDimensions (void) const
Camera * | getCamera () const
Camera * | getCullCamera () const
const CompositorPassSceneDef * | getDefinition () const
const CompositorNode * | getParentNode (void) const
RenderPassDescriptor * | getRenderPassDesc (void) const
CompositorShadowNode * | getShadowNode () const
const CompositorTextureVec & | getTextureDependencies (void) const
CompositorPassType | getType () const
bool | getUpdateShadowNode (void) const
virtual void | notifyCleared (void)
| @See CompositorNode::_notifyCleared More...
virtual void | notifyDestroyed (const UavBufferPacked *buffer)
virtual void | notifyDestroyed (TextureGpu *channel)
| @See CompositorNode::notifyDestroyed More...
virtual bool | notifyRecreated (const TextureGpu *channel)
| @See CompositorNode::notifyRecreated More...
virtual void | notifyRecreated (const UavBufferPacked *oldBuffer, UavBufferPacked *newBuffer)
void | operator delete (void *ptr)
void | operator delete (void *ptr, const char *, int, const char *)
void | operator delete (void *ptr, void *)
void | operator delete[] (void *ptr)
void | operator delete[] (void *ptr, const char *, int, const char *)
void * | operator new (size_t sz)
void * | operator new (size_t sz, const char *file, int line, const char *func)
| operator new, with debug line info More...
void * | operator new (size_t sz, void *ptr)
| placement operator new More...
void * | operator new[] (size_t sz)
void * | operator new[] (size_t sz, const char *file, int line, const char *func)
| array operator new, with debug line info More...
void | profilingBegin (void)
void | profilingEnd (void)
virtual void | resetNumPassesLeft (void)

## Detailed Description

Implementation of CompositorPass This implementation will perform main rendering, selecting several parameters (like viewport's visibility mask, first and last render queue to render) it will render the main scene.

into the specified RenderTarget

Author
  Matias N. Goldberg

Version
  1.0

## Constructor & Destructor Documentation

## ◆ CompositorPassScene()

Ogre::CompositorPassScene::CompositorPassScene | ( | const CompositorPassSceneDef * | definition,
|  | Camera * | defaultCamera,
|  | const RenderTargetViewDef * | rtv,
|  | CompositorNode * | parentNode
| ) |  |

Constructor.

Parameters

  definition |
  defaultCamera | Used when the definition's camera name is empty
  workspace | Workspace that ultimately owns us
  target | The RenderTarget we're supposed to draw to. Can be RenderWindow, RenderTexture, MRT, etc

## ◆ ~CompositorPassScene()

Ogre::CompositorPassScene::~CompositorPassScene | ( |  | ) |

## Member Function Documentation

## ◆ _placeBarriersAndEmulateUavExecution()

virtual void Ogre::CompositorPassScene::_placeBarriersAndEmulateUavExecution | ( | BoundUav | boundUavs[64],
|  | ResourceAccessMap & | uavsAccess,
|  | ResourceLayoutMap & | resourcesLayout
| ) |  |
| virtual

Emulates the execution of a UAV to understand memory dependencies, and adds a memory barrier / resource transition if we need to.

Remarks
  Note that an UAV->UAV resource transition is just a memory barrier.

Parameters

  boundUavs | [in/out] An array of the currently bound UAVs by slot. The derived class CompositorPassUav will write to them as part of the emulation. The base implementation reads from this value.
  uavsAccess | [in/out] A map with the last access flag used for each RenderTarget. We need it to identify RaR situations, which are the only ones that don't need a barrier (and also WaW hazards, when explicitly allowed by the pass). Note: We will set the access to ResourceAccess::Undefined to signal other passes that the UAV hazard already has a barrier (just in case there was one already created).
  resourcesLayout | [in/out] A map with the current layout of every RenderTarget used so far. Needed to identify if we need to change the resource layout to an UAV.

Reimplemented from Ogre::CompositorPass.

## ◆ _removeAllBarriers()

void Ogre::CompositorPass::_removeAllBarriers | ( | void |  | ) |
| inherited

## ◆ _setCustomCamera()

void Ogre::CompositorPassScene::_setCustomCamera | ( | Camera * | camera | ) |
| inline

## ◆ _setCustomCullCamera()

void Ogre::CompositorPassScene::_setCustomCullCamera | ( | Camera * | camera | ) |
| inline

## ◆ _setUpdateShadowNode()

void Ogre::CompositorPassScene::_setUpdateShadowNode | ( | bool | update | ) |
| inline

## ◆ addResourceTransition()

void Ogre::CompositorPass::addResourceTransition | ( | ResourceLayoutMap::iterator | currentLayout,
|  | ResourceLayout::Layout | newLayout,
|  | uint32 | readBarrierBits
| ) |  |
| inherited

## ◆ execute()

virtual void Ogre::CompositorPassScene::execute | ( | const Camera * | lodCamera | ) |
| virtual

Implements Ogre::CompositorPass.

## ◆ getActualDimensions()

Vector2 Ogre::CompositorPass::getActualDimensions | ( | void |  | ) | const
| inherited

## ◆ getCamera()

Camera* Ogre::CompositorPassScene::getCamera | ( |  | ) | const
| inline

## ◆ getCullCamera()

Camera* Ogre::CompositorPassScene::getCullCamera | ( |  | ) | const
| inline

## ◆ getDefinition()

const CompositorPassSceneDef* Ogre::CompositorPassScene::getDefinition | ( | void |  | ) | const
| inline

## ◆ getParentNode()

const CompositorNode* Ogre::CompositorPass::getParentNode | ( | void |  | ) | const
| inlineinherited

## ◆ getRenderPassDesc()

RenderPassDescriptor* Ogre::CompositorPass::getRenderPassDesc | ( | void |  | ) | const
| inlineinherited

## ◆ getShadowNode()

CompositorShadowNode* Ogre::CompositorPassScene::getShadowNode | ( |  | ) | const
| inline

## ◆ getTextureDependencies()

const CompositorTextureVec& Ogre::CompositorPass::getTextureDependencies | ( | void |  | ) | const
| inlineinherited

## ◆ getType()

CompositorPassType Ogre::CompositorPass::getType | ( | void |  | ) | const
| inlineinherited

## ◆ getUpdateShadowNode()

bool Ogre::CompositorPassScene::getUpdateShadowNode | ( | void |  | ) | const
| inline

## ◆ notifyCleared()

virtual void Ogre::CompositorPassScene::notifyCleared | ( | void |  | ) |
| virtual

@See CompositorNode::_notifyCleared

Reimplemented from Ogre::CompositorPass.

## ◆ notifyDestroyed() [1/2]

virtual void Ogre::CompositorPass::notifyDestroyed | ( | const UavBufferPacked * | buffer | ) |
| virtualinherited

## ◆ notifyDestroyed() [2/2]

virtual void Ogre::CompositorPass::notifyDestroyed | ( | TextureGpu * | channel | ) |
| virtualinherited

@See CompositorNode::notifyDestroyed

## ◆ notifyRecreated() [1/2]

virtual bool Ogre::CompositorPass::notifyRecreated | ( | const TextureGpu * | channel | ) |
| virtualinherited

@See CompositorNode::notifyRecreated

Reimplemented in Ogre::CompositorPassMipmap, and Ogre::CompositorPassIblSpecular.

## ◆ notifyRecreated() [2/2]

virtual void Ogre::CompositorPass::notifyRecreated | ( | const UavBufferPacked * | oldBuffer,
|  | UavBufferPacked * | newBuffer
| ) |  |
| virtualinherited

Reimplemented in Ogre::CompositorPassUav.

## ◆ operator delete() [1/3]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr | ) |
| inlineinherited

## ◆ operator delete() [2/3]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |
| ) |  |
| inlineinherited

## ◆ operator delete() [3/3]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | void * |
| ) |  |
| inlineinherited

## ◆ operator delete[]() [1/2]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr | ) |
| inlineinherited

## ◆ operator delete[]() [2/2]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |
| ) |  |
| inlineinherited

## ◆ operator new() [1/3]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz | ) |
| inlineinherited

## ◆ operator new() [2/3]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func
| ) |  |
| inlineinherited

operator new, with debug line info

## ◆ operator new() [3/3]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | void * | ptr
| ) |  |
| inlineinherited

placement operator new

## ◆ operator new[]() [1/2]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz | ) |
| inlineinherited

## ◆ operator new[]() [2/2]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func
| ) |  |
| inlineinherited

array operator new, with debug line info

## ◆ profilingBegin()

void Ogre::CompositorPass::profilingBegin | ( | void |  | ) |
| inherited

## ◆ profilingEnd()

void Ogre::CompositorPass::profilingEnd | ( | void |  | ) |
| inherited

## ◆ resetNumPassesLeft()

virtual void Ogre::CompositorPass::resetNumPassesLeft | ( | void |  | ) |
| virtualinherited

Reimplemented in Ogre::CompositorPassIblSpecular.

The documentation for this class was generated from the following file:

- OgreCompositorPassScene.h